import { c as J, a as K, t as Q, z as j, p as $, V as q, O as R, f as U, L as ee, G as te, i as ae, a2 as ie, a0 as re, a3 as le, v as se, a4 as ne, d as he, B as oe, b as ce, q as de, R as ue, a5 as ge, r as fe, e as Ie, y as Ne, C as me, x as xe, a6 as Fe, Y as be, o as _e, s as Ae, w as ye, F as Le, A as Ce, u as Se } from "./index-BtL_cLa8.js";
import { D as ke } from "./DataTable-CQ8fQnex.js";
import { _ as we } from "./Title-CIsKiWgN.js";
import { _ as Oe, u as Ge } from "./Tooltip-B1LgrF9R.js";
import { U as ve } from "./usePrinter-sRt2SKr2.js";
import { _ as pe } from "./Shape-B7Mekpyf.js";
import ze from "./BaseIcon-BHwqOTt4.js";
import Me from "./vue-ui-table-sparkline-DMHf03C9.js";
import Te from "./vue-ui-skeleton-DjFU2X3P.js";
import { S as Pe } from "./Slicer-ahFReg7h.js";
import Ve from "./vue-ui-accordion-Cjc683tN.js";
import { u as Z } from "./useNestedProp-CEAfm1tu.js";
import { _ as Re } from "./PackageVersion-BV3fHO46.js";
import { P as De } from "./PenAndPaper-CCOywdmm.js";
import { resolveComponent as P, openBlock as r, createElementBlock as l, normalizeClass as V, normalizeStyle as L, createBlock as D, createCommentVNode as c, createSlots as Be, withCtx as M, renderSlot as w, normalizeProps as B, guardReactiveProps as E, createVNode as X, createElementVNode as f, Fragment as I, renderList as m, toDisplayString as S, withDirectives as Ee, vModelCheckbox as He, createTextVNode as We } from "vue";
import { _ as Ye } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Xe = J(), qe = {
  name: "vue-ui-xy",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  components: {
    DataTable: ke,
    Shape: pe,
    Title: we,
    Tooltip: Oe,
    UserOptions: ve,
    BaseIcon: ze,
    TableSparkline: Me,
    Skeleton: Te,
    Slicer: Pe,
    Accordion: Ve,
    PackageVersion: Re,
    PenAndPaper: De
  },
  data() {
    this.dataset.forEach((u, t) => {
      [null, void 0].includes(u.series) && this.error({
        componentName: "VueUiXy",
        type: "datasetSerieAttribute",
        property: "series (number[])",
        index: t
      });
    });
    const a = this.config.downsample && this.config.downsample.threshold ? this.config.downsample.threshold : 500, s = Math.max(...this.dataset.map((u) => this.largestTriangleThreeBucketsArray({ data: u.series, threshold: a }).length)), o = {
      start: 0,
      end: s
    };
    return {
      themePalettes: K,
      themes: Q,
      slicerStep: 0,
      selectedScale: null,
      CTX: null,
      CANVAS: null,
      opacity: j,
      useSafeValues: !0,
      palette: $,
      height: 600,
      width: 1e3,
      viewBox: "0 0 1000 600",
      clientPosition: {
        x: 0,
        y: 0
      },
      canvasClientPosition: {
        x: 0,
        y: 0
      },
      icons: {
        line: "line",
        bar: "bar",
        plot: "plot"
      },
      isAnnotator: !1,
      isFullscreen: !1,
      isPrinting: !1,
      isImaging: !1,
      isTooltip: !1,
      mutableConfig: {
        dataLabels: {
          show: !0
        },
        showTooltip: !0,
        showTable: !1,
        isStacked: !1,
        useIndividualScale: !1
      },
      selectedSerieIndex: null,
      selectedRowIndex: null,
      segregatedSeries: [],
      uniqueId: J(),
      step: 0,
      tableStep: 0,
      titleStep: 0,
      slicer: o,
      __to__: null,
      maxX: s,
      showSparklineTable: !0,
      segregateStep: 0,
      sliderId: Xe,
      fontSizes: {
        xAxis: 18,
        yAxis: 12,
        dataLabels: 20,
        plotLabels: 10
      },
      plotRadii: {
        plot: 3,
        line: 3
      },
      selectedMinimapIndex: null
    };
  },
  watch: {
    dataset: {
      handler(a, s) {
        this.maxX = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({
          data: o.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        }).length)), this.slicer = {
          start: 0,
          end: this.maxX
        }, this.slicerStep += 1, this.segregateStep += 1;
      },
      deep: !0
    },
    config: {
      handler(a, s) {
        this.FINAL_CONFIG = this.prepareConfig(), this.prepareChart(), this.titleStep += 1, this.tableStep += 1;
      },
      deep: !0
    }
  },
  computed: {
    hasOptionsNoTitle() {
      return this.FINAL_CONFIG.chart.userOptions.show && (!this.FINAL_CONFIG.chart.title.show || !this.FINAL_CONFIG.chart.title.text);
    },
    minimap() {
      if (!this.FINAL_CONFIG.chart.zoom.minimap.show) return [];
      const a = this.datasetWithIds.filter((t) => !this.segregatedSeries.includes(t.id)), s = Math.max(...a.map((t) => t.series.length)), o = [];
      for (let t = 0; t < s; t += 1)
        o.push(a.map((e) => e.series[t] || 0).reduce((e, x) => (e || 0) + (x || 0), 0));
      const u = Math.min(...o);
      return o.map((t) => t + (u < 0 ? Math.abs(u) : 0));
    },
    customPalette() {
      return this.convertCustomPalette(this.FINAL_CONFIG.customPalette);
    },
    backgroundColor() {
      return this.FINAL_CONFIG.chart.backgroundColor;
    },
    slicerColor() {
      return this.FINAL_CONFIG.chart.zoom.color;
    },
    allScales() {
      const a = this.lineSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height,
        autoScaleYLabels: t.autoScaleYLabels
      })), s = this.barSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), o = this.plotSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        // FIX
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), u = [...a, ...s, ...o].flatMap((t) => t).length;
      return [...a, ...s, ...o].flatMap((t, e) => ({
        id: t.id,
        scaleLabel: t.scaleLabel,
        name: t.name,
        color: t.color,
        scale: t.scale,
        yOffset: t.yOffset,
        individualHeight: t.individualHeight,
        x: this.mutableConfig.isStacked ? this.drawingArea.left : this.drawingArea.left / u * (e + 1),
        yLabels: t.scaleYLabels || t.scale.ticks.map((x) => ({
          y: x >= 0 ? t.zero - t.individualHeight * (x / t.max) : t.zero + t.individualHeight * Math.abs(x) / t.max,
          value: x
        }))
      }));
    },
    isDataset() {
      return !!this.dataset && this.dataset.length;
    },
    chartFont() {
      const a = document.getElementById(`vue-ui-xy_${this.uniqueId}`);
      return window.getComputedStyle(a, null).getPropertyValue("font-family");
    },
    FINAL_CONFIG: {
      get: function() {
        return this.prepareConfig();
      },
      set: function(a) {
        return a;
      }
    },
    hasHighlightArea() {
      return Array.isArray(this.FINAL_CONFIG.chart.highlightArea) ? this.FINAL_CONFIG.chart.highlightArea.some((a) => a.show) : this.FINAL_CONFIG.chart.highlightArea && this.FINAL_CONFIG.chart.highlightArea.show;
    },
    highlightAreas() {
      if (Array.isArray(this.FINAL_CONFIG.chart.highlightArea))
        return this.FINAL_CONFIG.chart.highlightArea.map((s) => ({
          ...s,
          span: s.from === s.to ? 1 : s.to < s.from ? 0 : s.to - s.from + 1
        }));
      const a = this.FINAL_CONFIG.chart.highlightArea;
      return [{ ...a, span: a.from === a.to ? 1 : a.to < a.from ? 0 : a.to - a.from + 1 }];
    },
    xPadding() {
      return this.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : this.drawingArea.width / this.maxSeries / 2;
    },
    relativeZero() {
      return this.niceScale.min >= 0 ? 0 : Math.abs(this.niceScale.min);
    },
    absoluteMax() {
      return this.niceScale.max + this.relativeZero;
    },
    datasetWithIds() {
      return this.useSafeValues ? this.dataset.map((a, s) => ({
        ...a,
        series: this.largestTriangleThreeBucketsArray({
          data: a.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        }),
        id: `uniqueId_${s}`
      })) : this.dataset;
    },
    safeDataset() {
      return this.useSafeValues ? this.dataset.map((a, s) => {
        const o = this.largestTriangleThreeBucketsArray({
          data: a.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        });
        return {
          ...a,
          series: o.map((u) => this.isSafeValue(u) ? u : null).slice(this.slicer.start, this.slicer.end),
          color: this.convertColorToHex(a.color ? a.color : this.customPalette[s] ? this.customPalette[s] : this.palette[s]),
          id: `uniqueId_${s}`
        };
      }) : this.dataset;
    },
    relativeDataset() {
      return this.safeDataset.map((a, s) => ({
        ...a,
        series: a.series.map((o) => o + this.relativeZero),
        absoluteValues: a.series
      })).filter((a) => !this.segregatedSeries.includes(a.id));
    },
    tableSparklineDataset() {
      return this.relativeDataset.map((a) => {
        const s = a.absoluteValues.map((o) => [void 0, null].includes(o) ? 0 : o);
        return {
          id: a.id,
          name: a.name,
          color: a.color,
          values: this.fillArray(this.maxSeries, s)
        };
      });
    },
    tableSparklineConfig() {
      return {
        responsiveBreakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint,
        roundingValues: this.FINAL_CONFIG.table.rounding,
        showAverage: !1,
        showMedian: !1,
        showTotal: !1,
        fontFamily: this.FINAL_CONFIG.chart.fontFamily,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix,
        colNames: JSON.parse(JSON.stringify(this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values)),
        thead: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        tbody: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        userOptions: {
          show: !1
        }
      };
    },
    absoluteDataset() {
      return this.safeDataset.map((a, s) => ({
        absoluteIndex: s,
        ...a,
        series: a.series.map((o) => o + this.relativeZero),
        absoluteValues: a.series,
        segregate: () => this.segregate(a),
        isSegregated: this.segregatedSeries.includes(a.id)
      }));
    },
    barSet() {
      return this.activeSeriesWithStackRatios.filter((a) => a.type === "bar").map((a, s) => {
        this.checkAutoScaleError(a);
        const o = Math.min(...a.absoluteValues.filter((g) => ![null, void 0].includes(g))), u = Math.max(...a.absoluteValues.filter((g) => ![null, void 0].includes(g))), e = {
          ratios: a.absoluteValues.filter((g) => ![null, void 0].includes(g)).map((g) => (g - o) / (u - o)),
          valueMin: o,
          valueMax: u < 0 ? 0 : u
        }, x = {
          max: a.scaleMax || Math.max(...a.absoluteValues) || 1,
          min: a.scaleMin || Math.min(...a.absoluteValues.filter((g) => ![void 0, null].includes(g))) > 0 ? 0 : Math.min(...a.absoluteValues.filter((g) => ![null, void 0].includes(g)))
        }, A = a.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, k = 1.0000001, N = this.calculateNiceScaleWithExactExtremes(x.min, x.max === x.min ? x.max * k : x.max, A), F = this.calculateNiceScaleWithExactExtremes(e.valueMin, e.valueMax === e.valueMin ? e.valueMax * k : e.valueMax, A), T = N.min >= 0 ? 0 : Math.abs(N.min), v = 0, p = N.max + T, O = F.max + Math.abs(v), _ = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - a.cumulatedStackRatio) : 0, C = this.mutableConfig.isStacked ? this.drawingArea.height * a.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, z = this.drawingArea.bottom - _ - C * T / p, i = this.drawingArea.bottom - _ - C * v / O, h = this.absoluteDataset.filter((g) => g.type === "bar").filter((g) => !this.segregatedSeries.includes(g.id)).length, n = a.series.map((g, b) => {
          const W = this.mutableConfig.useIndividualScale ? (a.absoluteValues[b] + T) / p : this.ratioToMax(g), Y = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * b : this.drawingArea.left + this.slot.bar * s + this.slot.bar * b * h - this.barSlot / 2 - s * this.barPeriodGap;
          return {
            yOffset: this.checkNaN(_),
            individualHeight: this.checkNaN(C),
            x: this.checkNaN(Y),
            y: this.drawingArea.bottom - _ - C * W,
            value: a.absoluteValues[b],
            zeroPosition: this.checkNaN(z),
            individualMax: this.checkNaN(p),
            comment: a.comments && a.comments.slice(this.slicer.start, this.slicer.end)[b] || ""
          };
        }), d = a.absoluteValues.map((g) => F.min >= 0 ? (g - Math.abs(F.min)) / (F.max - Math.abs(F.min)) : (g + Math.abs(F.min)) / (F.max + Math.abs(F.min))), H = a.series.map((g, b) => {
          const W = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * b : this.drawingArea.left - this.slot.bar / 2 + this.slot.bar * s + this.slot.bar * b * this.absoluteDataset.filter((Y) => Y.type === "bar").filter((Y) => !this.segregatedSeries.includes(Y.id)).length;
          return {
            yOffset: this.checkNaN(_),
            individualHeight: this.checkNaN(C),
            x: this.checkNaN(W),
            y: this.checkNaN(this.drawingArea.bottom - this.checkNaN(_) - (this.checkNaN(C) * d[b] || 0)),
            value: a.absoluteValues[b],
            zeroPosition: this.checkNaN(z),
            individualMax: this.checkNaN(p),
            comment: a.comments && a.comments.slice(this.slicer.start, this.slicer.end)[b] || ""
          };
        }), y = N.ticks.map((g) => ({
          y: g >= 0 ? z - C * (g / p) : z + C * Math.abs(g) / p,
          value: g,
          prefix: a.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: a.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: a
        })), G = F.ticks.map((g) => {
          const b = (g - F.min) / (F.max - F.min);
          return {
            y: g >= 0 ? i - C * b : i + C * b,
            value: g,
            prefix: a.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: a.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: a
          };
        });
        return {
          ...a,
          yOffset: _,
          autoScaleYLabels: G,
          individualHeight: C,
          scaleYLabels: a.autoScaling ? G : y,
          individualScale: a.autoScaling ? F : N,
          individualMax: a.autoScaling ? O : p,
          zeroPosition: a.autoScaling ? i : z,
          plots: a.autoScaling ? H : n
        };
      });
    },
    activeSeriesLength() {
      return this.absoluteDataset.length;
    },
    activeSeriesWithStackRatios() {
      return this.assignStackRatios(this.absoluteDataset.filter((a) => !this.segregatedSeries.includes(a.id)));
    },
    lineSet() {
      return this.activeSeriesWithStackRatios.filter((a) => a.type === "line").map((a) => {
        this.checkAutoScaleError(a);
        const s = Math.min(...a.absoluteValues.filter((g) => ![void 0, null].includes(g))), o = Math.max(...a.absoluteValues.filter((g) => ![void 0, null].includes(g))) || 1, t = {
          ratios: a.absoluteValues.filter((g) => ![null, void 0].includes(g)).map((g) => (g - s) / (o - s)),
          valueMin: s,
          valueMax: o
        }, e = {
          max: a.scaleMax || Math.max(...a.absoluteValues) || 1,
          min: a.scaleMin || (Math.min(...a.absoluteValues) > 0 ? 0 : Math.min(...a.absoluteValues))
        }, x = a.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, A = 1.0000001, k = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * A : e.max, x), N = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax === t.valueMin ? t.valueMax * A : t.valueMax, x), F = k.min >= 0 ? 0 : Math.abs(k.min), T = 0, v = k.max + Math.abs(F), p = N.max + Math.abs(T), O = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - a.cumulatedStackRatio) : 0, _ = this.mutableConfig.isStacked ? this.drawingArea.height * a.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, C = this.drawingArea.bottom - O - _ * F / v, z = this.drawingArea.bottom - O - _ * T / p, i = a.series.map((g, b) => {
          const W = this.mutableConfig.useIndividualScale ? (a.absoluteValues[b] + Math.abs(F)) / v : this.ratioToMax(g);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * b),
            y: this.checkNaN(this.drawingArea.bottom - O - _ * W),
            value: a.absoluteValues[b],
            comment: a.comments && a.comments.slice(this.slicer.start, this.slicer.end)[b] || ""
          };
        }), h = a.absoluteValues.map((g) => N.min >= 0 ? (g - Math.abs(N.min)) / (N.max - Math.abs(N.min)) : (g + Math.abs(N.min)) / (N.max + Math.abs(N.min))), n = a.series.map((g, b) => [void 0, null].includes(a.absoluteValues[b]) ? {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * b),
          y: C,
          value: a.absoluteValues[b],
          comment: a.comments && a.comments.slice(this.slicer.start, this.slicer.end)[b] || ""
        } : {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * b),
          y: this.checkNaN(this.drawingArea.bottom - O - (_ * h[b] || 0)),
          value: a.absoluteValues[b],
          comment: a.comments && a.comments.slice(this.slicer.start, this.slicer.end)[b] || ""
        }), d = this.createSmoothPath(i), H = this.createSmoothPath(n), y = k.ticks.map((g) => ({
          y: g >= 0 ? C - _ * (g / v) : C + _ * Math.abs(g) / v,
          value: g,
          prefix: a.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: a.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: a
        })), G = N.ticks.map((g) => {
          const b = (g - N.min) / (N.max - N.min);
          return {
            y: g >= 0 ? z - _ * b : z + _ * b,
            value: g,
            prefix: a.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: a.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: a
          };
        });
        return {
          ...a,
          yOffset: O,
          autoScaleYLabels: G,
          individualHeight: _,
          scaleYLabels: a.autoScaling ? G : y,
          individualScale: a.autoScaling ? N : k,
          individualMax: a.autoScaling ? p : v,
          zeroPosition: a.autoScaling ? z : C,
          curve: a.autoScaling ? H : d,
          plots: a.autoScaling ? n : i,
          area: a.useArea ? this.mutableConfig.useIndividualScale ? this.createIndividualArea(a.autoScaling ? n : i, a.autoScaling ? z : C) : this.createArea(i) : ""
        };
      });
    },
    plotSet() {
      return this.activeSeriesWithStackRatios.filter((a) => a.type === "plot").map((a) => {
        this.checkAutoScaleError(a);
        const s = Math.min(...a.absoluteValues.filter((y) => ![null, void 0].includes(y))), o = Math.max(...a.absoluteValues.filter((y) => ![null, void 0].includes(y))) || 1, t = {
          ratios: a.absoluteValues.filter((y) => ![null, void 0].includes(y)).map((y) => (y - s) / (o - s)),
          valueMin: s,
          valueMax: o
        }, e = {
          max: a.scaleMax || Math.max(...a.absoluteValues) || 1,
          min: a.scaleMin || Math.min(...a.absoluteValues) > 0 ? 0 : Math.min(...a.absoluteValues)
        }, x = a.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, A = 1.0000001, k = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * A : e.max, x), N = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax === t.valueMin ? t.valueMax * A : t.valueMax, x), F = k.min >= 0 ? 0 : Math.abs(k.min), T = 0, v = k.max + F, p = N.max + Math.abs(T), O = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - a.cumulatedStackRatio) : 0, _ = this.mutableConfig.isStacked ? this.drawingArea.height * a.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, C = this.drawingArea.bottom - O - _ * F / v, z = this.drawingArea.bottom - O - _ * T / p, i = a.series.map((y, G) => {
          const g = this.mutableConfig.useIndividualScale ? (a.absoluteValues[G] + Math.abs(F)) / v : this.ratioToMax(y);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * G),
            y: this.checkNaN(this.drawingArea.bottom - O - _ * g),
            value: a.absoluteValues[G],
            comment: a.comments && a.comments.slice(this.slicer.start, this.slicer.end)[G] || ""
          };
        }), h = a.absoluteValues.map((y) => N.min >= 0 ? (y - Math.abs(N.min)) / (N.max - Math.abs(N.min)) : (y + Math.abs(N.min)) / (N.max + Math.abs(N.min))), n = a.series.map((y, G) => ({
          x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * G),
          y: this.checkNaN(this.drawingArea.bottom - O - (_ * h[G] || 0)),
          value: a.absoluteValues[G],
          comment: a.comments && a.comments.slice(this.slicer.start, this.slicer.end)[G] || ""
        })), d = k.ticks.map((y) => ({
          y: y >= 0 ? C - _ * (y / v) : C + _ * Math.abs(y) / v,
          value: y,
          prefix: a.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: a.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: a
        })), H = N.ticks.map((y) => {
          const G = (y - N.min) / (N.max - N.min);
          return {
            y: y >= 0 ? z - _ * G : z + _ * G,
            value: y,
            prefix: a.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: a.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: a
          };
        });
        return {
          ...a,
          yOffset: O,
          autoScaleYLabels: H,
          individualHeight: _,
          scaleYLabels: a.autoScaling ? H : d,
          individualScale: a.autoScaling ? N : k,
          individualMax: a.autoScaling ? p : v,
          zeroPosition: a.autoScaling ? z : C,
          plots: a.autoScaling ? n : i
        };
      });
    },
    drawingArea() {
      const a = this.mutableConfig.useIndividualScale && this.FINAL_CONFIG.chart.grid.labels.show ? this.absoluteDataset.filter((s) => !this.segregatedSeries.includes(s.id)).length * (this.mutableConfig.isStacked ? 0 : this.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth) : 0;
      return {
        top: this.FINAL_CONFIG.chart.padding.top,
        right: this.width - this.FINAL_CONFIG.chart.padding.right,
        bottom: this.height - this.FINAL_CONFIG.chart.padding.bottom,
        left: this.FINAL_CONFIG.chart.padding.left + a,
        height: this.height - (this.FINAL_CONFIG.chart.padding.top + this.FINAL_CONFIG.chart.padding.bottom),
        width: this.width - (this.FINAL_CONFIG.chart.padding.right + this.FINAL_CONFIG.chart.padding.left + a)
      };
    },
    max() {
      return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax ? this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax : Math.max(...this.safeDataset.filter((a) => !this.segregatedSeries.includes(a.id)).map((a) => Math.max(...a.series)));
    },
    min() {
      if (this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin !== null)
        return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin;
      const a = Math.min(...this.safeDataset.filter((s) => !this.segregatedSeries.includes(s.id)).map((s) => Math.min(...s.series)));
      return a > 0 ? 0 : a;
    },
    niceScale() {
      return this.calculateNiceScaleWithExactExtremes(this.min, this.max < 0 ? 0 : this.max, this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps);
    },
    maxSeries() {
      return this.slicer.end - this.slicer.start;
    },
    timeLabels() {
      const a = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({ data: o.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length)), s = [];
      for (let o = 0; o < a; o += 1)
        s.push({
          text: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[o] || String(o),
          absoluteIndex: o
        });
      return s.slice(this.slicer.start, this.slicer.end);
    },
    slot() {
      return {
        bar: this.drawingArea.width / this.maxSeries / this.safeDataset.filter((a) => a.type === "bar").filter((a) => !this.segregatedSeries.includes(a.id)).length,
        plot: this.drawingArea.width / this.maxSeries,
        line: this.drawingArea.width / this.maxSeries
      };
    },
    barSlot() {
      const a = this.safeDataset.filter((s) => s.type === "bar").filter((s) => !this.segregatedSeries.includes(s.id)).length;
      return this.drawingArea.width / this.maxSeries / a - this.barPeriodGap * a;
    },
    barPeriodGap() {
      return this.slot.line * this.FINAL_CONFIG.bar.periodGap;
    },
    maxSlot() {
      return Math.max(...Object.values(this.slot).filter((a) => a !== 1 / 0));
    },
    table() {
      if (this.safeDataset.length === 0) return { head: [], body: [], config: {}, columnNames: [] };
      const a = this.relativeDataset.map((o) => ({
        label: o.name,
        color: o.color,
        type: o.type
      })), s = [];
      return this.timeLabels.forEach((o, u) => {
        const t = [o.text];
        this.relativeDataset.forEach((e) => {
          t.push(this.canShowValue(e.absoluteValues[u]) ? Number(e.absoluteValues[u].toFixed(this.FINAL_CONFIG.table.rounding)) : "");
        }), s.push(t);
      }), { head: a, body: s };
    },
    dataTable() {
      const a = this.FINAL_CONFIG.table.showSum;
      let s = [""].concat(this.relativeDataset.map((e) => e.name));
      a && (s = s.concat(' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>'));
      let o = [];
      for (let e = 0; e < this.maxSeries; e += 1) {
        const x = this.relativeDataset.map((A) => A.absoluteValues[e] ?? 0).reduce((A, k) => A + k, 0);
        o.push(
          [
            this.timeLabels[e].text ?? "-"
          ].concat(this.relativeDataset.map(
            (A) => this.applyDataLabel(
              A.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : A.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
              A.absoluteValues[e] ?? 0,
              this.dataLabel({
                p: A.prefix || this.FINAL_CONFIG.chart.labels.prefix,
                v: A.absoluteValues[e] ?? 0,
                s: A.suffix || this.FINAL_CONFIG.chart.labels.suffix,
                r: this.FINAL_CONFIG.table.rounding
              })
            )
          )).concat(a ? (x ?? 0).toFixed(this.FINAL_CONFIG.table.rounding) : [])
        );
      }
      const u = {
        th: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        td: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        breakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint
      }, t = [this.FINAL_CONFIG.table.columnNames.period].concat(this.relativeDataset.map((e) => e.name)).concat(this.FINAL_CONFIG.table.columnNames.total);
      return { head: s, body: o, config: u, colNames: t };
    },
    dataTooltipSlot() {
      return {
        datapoint: this.selectedSeries,
        seriesIndex: this.selectedSerieIndex,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      };
    },
    selectedSeries() {
      return this.relativeDataset.map((a) => ({
        shape: a.shape || null,
        name: a.name,
        color: a.color,
        type: a.type,
        value: a.absoluteValues.find((s, o) => o === this.selectedSerieIndex),
        comments: a.comments || [],
        prefix: a.prefix || this.FINAL_CONFIG.chart.labels.prefix,
        suffix: a.suffix || this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    tooltipContent() {
      let a = "", s = this.selectedSeries.map((t) => t.value).filter((t) => this.isSafeValue(t) && t !== null).reduce((t, e) => Math.abs(t) + Math.abs(e), 0);
      const o = this.timeLabels[this.selectedSerieIndex], u = this.FINAL_CONFIG.chart.tooltip.customFormat;
      return this.isFunction(u) && this.functionReturnsString(() => u({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      })) ? u({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      }) : (o && o.text && this.FINAL_CONFIG.chart.tooltip.showTimeLabel && (a += `<div style="padding-bottom: 6px; margin-bottom: 4px; border-bottom: 1px solid ${this.FINAL_CONFIG.chart.tooltip.borderColor}; width:100%">${o.text}</div>`), this.selectedSeries.forEach((t) => {
        if (this.isSafeValue(t.value)) {
          let e = "", x = "";
          switch (this.icons[t.type]) {
            case "bar":
              e = `<svg viewBox="0 0 12 12" height="14" width="14"><rect x="0" y="0" rx="1" stroke="none" height="12" width="12" fill="${t.color}" /></svg>`;
              break;
            case "line":
              !t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape) ? x = `<circle cx="10" cy="8" r="4" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" fill="${t.color}" />` : t.shape === "triangle" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "square" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "diamond" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "pentagon" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "hexagon" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "star" && (x = `<polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" fill="${t.color}" points="${q({ plot: { x: 10, y: 8 }, radius: 4 })}" />`), e = `<svg viewBox="0 0 20 12" height="14" width="20"><rect rx="1.5" x="0" y="6.5" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" height="3" width="20" fill="${t.color}" />${x}</svg>`;
              break;
            case "plot":
              if (!t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape)) {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" /></svg>`;
                break;
              }
              if (t.shape === "star") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" points="${q({ plot: { x: 6, y: 6 }, radius: 5 })}" /></svg>`;
                break;
              }
              if (t.shape === "triangle") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 6, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "square") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 6, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "diamond") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 5, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "pentagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 5, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "hexagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 5, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
          }
          a += `<div style="display:flex;flex-direction:row; align-items:center;gap:3px;"><div style="width:20px">${e}</div> ${t.name}: <b>${this.FINAL_CONFIG.chart.tooltip.showValue ? this.applyDataLabel(
            t.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : t.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
            t.value,
            this.dataLabel({
              p: t.prefix,
              v: t.value,
              s: t.suffix,
              r: this.FINAL_CONFIG.chart.tooltip.roundingValue
            }),
            { datapoint: t }
          ) : ""}</b> ${this.FINAL_CONFIG.chart.tooltip.showPercentage ? `(${U({
            v: this.checkNaN(Math.abs(t.value) / s * 100),
            s: "%",
            r: this.FINAL_CONFIG.chart.tooltip.roundingPercentage
          })})` : ""}</div>`, this.FINAL_CONFIG.chart.comments.showInTooltip && t.comments.length && t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex] && (a += `<div class="vue-data-ui-tooltip-comment" style="background:${t.color}20; padding: 6px; margin-bottom: 6px; border-left: 1px solid ${t.color}">${t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex]}</div>`);
        }
      }), `<div style="border-radius:4px;padding:12px;font-variant-numeric: tabular-nums;color:${this.FINAL_CONFIG.chart.tooltip.color}">${a}</div>`);
    },
    svg() {
      return {
        height: this.height,
        width: this.width
      };
    },
    yLabels() {
      return this.niceScale.ticks.map((a) => ({
        y: a >= 0 ? this.zero - this.drawingArea.height * this.ratioToMax(a) : this.zero + this.drawingArea.height * this.ratioToMax(Math.abs(a)),
        value: a,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    zero() {
      return this.drawingArea.bottom - this.drawingArea.height * this.ratioToMax(this.relativeZero);
    }
  },
  mounted() {
    this.prepareChart(), this.setupSlicer(), document.addEventListener("mousemove", (a) => {
      this.clientPosition = {
        x: a.clientX,
        y: a.clientY
      };
    });
  },
  methods: {
    abbreviate: ee,
    adaptColorToBackground: te,
    applyDataLabel: ae,
    assignStackRatios: ie,
    calcLinearProgression: re,
    calculateNiceScaleWithExactExtremes: le,
    checkNaN: se,
    closestDecimal: ne,
    convertColorToHex: he,
    convertConfigColors: oe,
    convertCustomPalette: ce,
    createCsvContent: de,
    createSmoothPath: ue,
    createTSpans: ge,
    dataLabel: U,
    downloadCsv: fe,
    error: Ie,
    functionReturnsString: Ne,
    hasDeepProperty: me,
    isFunction: xe,
    isSafeValue: Fe,
    largestTriangleThreeBucketsArray: be,
    objectIsEmpty: _e,
    setOpacity: Ae,
    shiftHue: ye,
    translateSize: Le,
    treeShake: Ce,
    useMouse: Ge,
    useNestedProp: Z,
    toggleAnnotator() {
      this.isAnnotator = !this.isAnnotator;
    },
    selectTimeLabel(a, s) {
      const o = this.relativeDataset.map((u) => ({
        shape: u.shape || null,
        name: u.name,
        color: u.color,
        type: u.type,
        value: u.absoluteValues.find((t, e) => e === s),
        comments: u.comments || [],
        prefix: u.prefix || this.FINAL_CONFIG.chart.labels.prefix,
        suffix: u.suffix || this.FINAL_CONFIG.chart.labels.suffix
      }));
      this.$emit("selectTimeLabel", {
        datapoint: o,
        absoluteIndex: a.absoluteIndex,
        label: a.text
      });
    },
    getHighlightAreaPosition(a) {
      const s = this.drawingArea.left + this.drawingArea.width / this.maxSeries * (a.from - this.slicer.start), o = this.drawingArea.width / (this.slicer.end - this.slicer.start) * a.span < 0 ? 1e-5 : this.drawingArea.width / (this.slicer.end - this.slicer.start) * a.span;
      return {
        x: s < this.drawingArea.left ? this.drawingArea.left : s,
        width: o
      };
    },
    prepareConfig() {
      const a = Se().vue_ui_xy;
      if (!Object.keys(this.config || {}).length)
        return a;
      const s = this.useNestedProp({
        userConfig: this.config,
        defaultConfig: a
      });
      return this.config && this.hasDeepProperty(this.config, "chart.highlightArea") && (Array.isArray(this.config.chart.highlightArea) ? s.chart.highlightArea = this.config.chart.highlightArea : s.chart.highlightArea = [this.config.chart.highlightArea]), this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMin") ? s.chart.grid.labels.yAxis.scaleMin = this.config.chart.grid.labels.yAxis.scaleMin : s.chart.grid.labels.yAxis.scaleMin = null, this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMax") ? s.chart.grid.labels.yAxis.scaleMax = this.config.chart.grid.labels.yAxis.scaleMax : s.chart.grid.labels.yAxis.scaleMax = null, this.config && this.hasDeepProperty(this.config, "chart.zoom.startIndex") ? s.chart.zoom.startIndex = this.config.chart.zoom.startIndex : s.chart.zoom.startIndex = null, this.config && this.hasDeepProperty(this.config, "chart.zoom.endIndex") ? s.chart.zoom.endIndex = this.config.chart.zoom.endIndex : s.chart.zoom.endIndex = null, s.theme ? {
        ...Z({
          userConfig: this.themes.vue_ui_xy[s.theme] || this.config,
          defaultConfig: s
        }),
        customPalette: this.themePalettes[s.theme] || this.palette
      } : s;
    },
    prepareChart() {
      if (this.objectIsEmpty(this.dataset) ? this.error({
        componentName: "VueUiXy",
        type: "dataset"
      }) : this.dataset.forEach((a, s) => {
        [null, void 0].includes(a.name) && this.error({
          componentName: "VueUiXy",
          type: "datasetSerieAttribute",
          property: "name (string)",
          index: s
        });
      }), this.FINAL_CONFIG.showWarnings && this.dataset.forEach((a) => {
        a.series.forEach((s, o) => {
          this.isSafeValue(s) || console.warn(`VueUiXy has detected an unsafe value in your dataset:
-----> The serie '${a.name}' contains the value '${s}' at index ${o}.
'${s}' was converted to null to allow the chart to display.`);
        });
      }), this.mutableConfig = {
        dataLabels: {
          show: !0
        },
        showTooltip: this.FINAL_CONFIG.chart.tooltip.show === !0,
        showTable: this.FINAL_CONFIG.showTable === !0,
        isStacked: this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked,
        useIndividualScale: this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale
      }, this.FINAL_CONFIG.responsive) {
        const s = this.$refs.chart.parentNode, { height: o, width: u } = s.getBoundingClientRect();
        let t = null, e = 0;
        this.FINAL_CONFIG.chart.title.show && (t = this.$refs.chartTitle, e = t.getBoundingClientRect().height);
        let x = null, A = 0;
        this.FINAL_CONFIG.chart.zoom.show && this.maxX > 6 && this.isDataset && (x = this.$refs.chartSlicer.$el, A = x.getBoundingClientRect().height);
        let k = null, N = 0;
        this.FINAL_CONFIG.chart.legend.show && (k = this.$refs.chartLegend, N = k.getBoundingClientRect().height);
        let F = 0;
        this.$refs.source && (F = this.$refs.source.getBoundingClientRect().height);
        let T = 0;
        this.$refs.noTitle && (T = this.$refs.noTitle.getBoundingClientRect().height), this.height = o - e - N - A - F - T, this.width = u, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes(), new ResizeObserver((p) => {
          for (const O of p)
            this.$refs.chartTitle && (e = this.$refs.chartTitle.getBoundingClientRect().height), this.$refs.chartSlicer && this.$refs.chartSlicer.$el && (A = this.$refs.chartSlicer.$el.getBoundingClientRect().height), this.$refs.chartLegend && (N = this.$refs.chartLegend.getBoundingClientRect().height), this.$refs.source && (F = this.$refs.source.getBoundingClientRect().height), this.height = O.contentBoxSize[0].blockSize - e - N - A - F - 24, this.width = O.contentBoxSize[0].inlineSize, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes();
        }).observe(s);
      } else
        this.height = this.FINAL_CONFIG.chart.height, this.width = this.FINAL_CONFIG.chart.width, this.viewBox = `0 0 ${this.width} ${this.height}`, this.fontSizes.dataLabels = this.FINAL_CONFIG.chart.grid.labels.fontSize, this.fontSizes.yAxis = this.FINAL_CONFIG.chart.grid.labels.axis.fontSize, this.fontSizes.xAxis = this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize, this.fontSizes.plotLabels = this.FINAL_CONFIG.chart.labels.fontSize, this.plotRadii.plot = this.FINAL_CONFIG.plot.radius, this.plotRadii.line = this.FINAL_CONFIG.line.radius;
    },
    selectMinimapIndex(a) {
      this.selectedMinimapIndex = a;
    },
    convertSizes() {
      this.fontSizes.dataLabels = this.translateSize({
        relator: this.height,
        adjuster: 400,
        source: this.FINAL_CONFIG.chart.grid.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.yAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.axis.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.xAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.plotLabels = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.chart.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.plotRadii.plot = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.plot.radius,
        threshold: 1,
        fallback: 1
      }), this.plotRadii.line = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.line.radius,
        threshold: 1,
        fallback: 1
      });
    },
    toggleStack() {
      this.mutableConfig.isStacked = !this.mutableConfig.isStacked, this.mutableConfig.isStacked ? this.mutableConfig.useIndividualScale = !0 : this.mutableConfig.useIndividualScale = this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale;
    },
    toggleTable() {
      this.mutableConfig.showTable = !this.mutableConfig.showTable;
    },
    toggleLabels() {
      this.mutableConfig.dataLabels.show = !this.mutableConfig.dataLabels.show;
    },
    toggleTooltip() {
      this.mutableConfig.showTooltip = !this.mutableConfig.showTooltip;
    },
    checkAutoScaleError(a) {
      a.autoScaling && (this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale || console.warn(`VueUiXy (datapoint: ${a.name}) : autoScaling only works when config.chart.grid.labels.yAxis.useIndividualScale is set to true`), this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked || console.warn(`VueUiXy (datapoint: ${a.name}) : autoScaling only works when config.chart.grid.labels.yAxis.stacked is set to true`));
    },
    createArea(a) {
      if (!a[0]) return [-10, -10, "", -10, -10];
      const s = { x: a[0].x, y: this.zero }, o = { x: a.at(-1).x, y: this.zero }, u = [];
      return a.forEach((t) => {
        u.push(`${t.x},${t.y} `);
      }), [s.x, s.y, ...u, o.x, o.y].toString();
    },
    createIndividualArea(a, s) {
      if (!a[0]) return [-10, -10, "", -10, -10];
      const o = { x: a[0] ? a[0].x : Math.min(...a.filter((e) => !!e).map((e) => e.x)), y: s }, u = { x: a.at(-1) ? a.at(-1).x : Math.min(...a.filter((e) => !!e).map((e) => e.x)), y: s }, t = [];
      return a.filter((e) => !!e).forEach((e) => {
        t.push(`${e.x},${e.y} `);
      }), [o.x, o.y, ...t, u.x, u.y].toString();
    },
    createStar: q,
    createPolygonPath: R,
    fillArray(a, s) {
      let o = Array(a).fill(0);
      for (let u = 0; u < s.length && u < a; u += 1)
        o[u] = s[u];
      return o;
    },
    async setupSlicer() {
      (this.FINAL_CONFIG.chart.zoom.startIndex !== null || this.FINAL_CONFIG.chart.zoom.endIndex !== null) && this.$refs.chartSlicer ? (this.FINAL_CONFIG.chart.zoom.startIndex !== null && (await this.$nextTick(), await this.$nextTick(), this.$refs.chartSlicer.setStartValue(this.FINAL_CONFIG.chart.zoom.startIndex)), this.FINAL_CONFIG.chart.zoom.endIndex !== null && (await this.$nextTick(), await this.$nextTick(), this.$refs.chartSlicer.setEndValue(this.validSlicerEnd(this.FINAL_CONFIG.chart.zoom.endIndex + 1)))) : (this.slicer = {
        start: 0,
        end: Math.max(...this.dataset.map((a) => this.largestTriangleThreeBucketsArray({ data: a.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length))
      }, this.slicerStep += 1);
    },
    refreshSlicer() {
      this.setupSlicer();
    },
    validSlicerEnd(a) {
      const s = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({ data: o.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length));
      return a > s ? s : a < 0 || this.FINAL_CONFIG.chart.zoom.startIndex !== null && a < this.FINAL_CONFIG.chart.zoom.startIndex ? this.FINAL_CONFIG.chart.zoom.startIndex !== null ? this.FINAL_CONFIG.chart.zoom.startIndex + 1 : 1 : a;
    },
    calcRectHeight(a) {
      return a.value >= 0 ? this.checkNaN(this.zero - a.y <= 0 ? 1e-5 : this.zero - a.y) : this.checkNaN(a.y - this.zero <= 0 ? 1e-5 : a.y - this.zero);
    },
    calcIndividualHeight(a) {
      return a.value >= 0 ? this.checkNaN(a.zeroPosition - a.y <= 0 ? 1e-5 : a.zeroPosition - a.y) : this.checkNaN(a.y - a.zeroPosition <= 0 ? 1e-5 : a.zeroPosition - a.y);
    },
    calcRectWidth() {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.slot.line - this.drawingArea.width / this.maxSeries * 0.1 : this.slot.bar;
    },
    calcRectX(a) {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? a.x + this.drawingArea.width / this.maxSeries * 0.05 : a.x + this.slot.bar / 2;
    },
    calcRectY(a) {
      return a.value >= 0 ? a.y : this.zero;
    },
    calcIndividualRectY(a) {
      return a.value >= 0 ? a.y : [null, void 0, NaN, 1 / 0, -1 / 0].includes(a.zeroPosition) ? 0 : a.zeroPosition;
    },
    canShowValue(a) {
      return ![null, void 0, NaN, 1 / 0, -1 / 0].includes(a);
    },
    findClosestValue(a, s) {
      let o = s[0], u = Math.abs(a - s[0]);
      for (let t = 1; t < s.length; t += 1) {
        const e = Math.abs(a - s[t]);
        e < u && s[t] < a && (o = s[t], u = e);
      }
      return o;
    },
    ratioToMax(a) {
      return a / (this.canShowValue(this.absoluteMax) ? this.absoluteMax : 1);
    },
    selectX(a) {
      this.$emit(
        "selectX",
        {
          dataset: this.relativeDataset.map((s) => ({
            name: s.name,
            value: [null, void 0, NaN].includes(s.absoluteValues[a]) ? null : s.absoluteValues[a],
            color: s.color,
            type: s.type
          })),
          index: a,
          indexLabel: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[a]
        }
      );
    },
    getData() {
      return this.absoluteDataset.map((a) => ({
        values: a.absoluteValues,
        color: a.color,
        name: a.name,
        type: a.type
      }));
    },
    segregate(a) {
      if (this.segregatedSeries.includes(a.id))
        this.segregatedSeries = this.segregatedSeries.filter((s) => s !== a.id);
      else {
        if (this.segregatedSeries.length + 1 === this.safeDataset.length) return;
        this.segregatedSeries.push(a.id);
      }
      this.$emit("selectLegend", this.relativeDataset.map((s) => ({
        name: s.name,
        values: s.absoluteValues,
        color: s.color,
        type: s.type
      }))), this.segregateStep += 1;
    },
    toggleTooltipVisibility(a, s = null) {
      this.isTooltip = a, a ? this.selectedSerieIndex = s : this.selectedSerieIndex = null;
    },
    toggleFullscreen(a) {
      this.isFullscreen = a, this.step += 1;
    },
    showSpinnerPdf() {
      this.isPrinting = !0;
    },
    async generatePdf() {
      this.showSpinnerPdf(), clearTimeout(this.__to__), this.isPrinting = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: a } = await import("./pdf-B7oVat64.js");
          await a({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy"
          });
        } catch (a) {
          console.error("Error generating PDF:", a);
        } finally {
          this.isPrinting = !1;
        }
      }, 100);
    },
    generateCsv() {
      const a = [[this.FINAL_CONFIG.chart.title.text], [this.FINAL_CONFIG.chart.title.subtitle.text], [""]], s = ["", ...this.table.head.map((e) => e.label)], o = this.table.body, u = a.concat([s]).concat(o), t = this.createCsvContent(u);
      this.downloadCsv({ csvContent: t, title: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy" });
    },
    showSpinnerImage() {
      this.isImaging = !0;
    },
    async generateImage() {
      this.showSpinnerImage(), clearTimeout(this.__to__), this.isImaging = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: a } = await import("./img-DGzWcJ4Y.js");
          await a({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy",
            format: "png"
          });
        } catch (a) {
          console.error("Error generating image:", a);
        } finally {
          this.isImaging = !1;
        }
      }, 100);
    }
  }
}, Ue = ["id"], Ze = {
  key: 1,
  ref: "noTitle",
  class: "vue-data-ui-no-title-space",
  style: "height:36px; width: 100%; background:transparent"
}, Je = ["viewBox"], Ke = { key: 0 }, Qe = { class: "vue-ui-xy-grid" }, je = ["stroke", "x1", "x2", "y1", "y2"], $e = ["stroke", "x1", "x2", "y1", "y2"], et = { key: 1 }, tt = ["x1", "x2", "y1", "y2", "stroke"], at = ["x1", "x2", "y1", "y2", "stroke"], it = ["x1", "x2", "y1", "y2", "stroke"], rt = { key: 3 }, lt = ["x1", "x2", "y1", "y2", "stroke"], st = ["id"], nt = ["stop-color"], ht = ["stop-color"], ot = ["stop-color"], ct = ["id"], dt = ["stop-color"], ut = ["stop-color"], gt = ["stop-color"], ft = ["id"], It = ["stop-color"], Nt = ["stop-color"], mt = ["id"], xt = ["stop-color"], Ft = ["stop-color"], bt = ["id"], _t = ["stop-color"], At = ["stop-color"], yt = ["x", "y", "height", "width", "fill"], Lt = ["x", "y", "width"], Ct = ["x", "y", "height", "width", "fill"], St = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], kt = ["width", "x", "y"], wt = { key: 0 }, Ot = ["id"], Gt = ["fill"], vt = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], pt = ["x", "y", "font-size", "fill"], zt = ["stroke", "x1", "x2", "y1", "y2"], Mt = { key: 2 }, Tt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], Pt = ["x", "y", "width", "height", "stroke", "stroke-width", "stroke-linecap", "stroke-linejoin", "stroke-dasharray"], Vt = { key: 4 }, Rt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Dt = ["fill", "font-size", "transform"], Bt = ["x1", "x2", "y1", "y2", "stroke"], Et = ["x", "y", "font-size", "fill"], Ht = ["x1", "x2", "y1", "y2", "stroke"], Wt = ["x", "y", "font-size", "fill"], Yt = ["width", "x", "y"], Xt = { style: { width: "100%" } }, qt = { key: 0 }, Ut = ["id"], Zt = ["fill"], Jt = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], Kt = ["x", "y", "font-size", "fill"], Qt = ["d", "stroke", "stroke-width", "stroke-dasharray"], jt = { key: 1 }, $t = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], ea = { key: 0 }, ta = ["d", "fill"], aa = ["d", "fill"], ia = ["d", "stroke", "stroke-width", "stroke-dasharray"], ra = { key: 2 }, la = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], sa = ["width", "x", "y"], na = { style: { width: "100%" } }, ha = { key: 3 }, oa = ["id"], ca = ["fill"], da = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], ua = ["x", "y", "font-size", "fill"], ga = { key: 5 }, fa = ["x", "y", "font-size", "fill"], Ia = ["x", "y", "font-size", "fill", "font-weight"], Na = { key: 6 }, ma = ["x", "y", "font-size", "fill"], xa = ["x", "y"], Fa = ["x", "y"], ba = { key: 7 }, _a = ["x", "y", "font-size", "fill"], Aa = ["x", "y"], ya = ["x", "y"], La = ["x", "y", "font-size", "fill", "innerHTML"], Ca = ["x", "y", "font-size", "fill", "innerHTML"], Sa = ["x", "y", "font-size", "fill", "innerHTML"], ka = ["x", "y", "font-size", "fill", "innerHTML"], wa = ["x", "y", "width", "height", "fill", "onMouseenter"], Oa = ["font-size", "fill", "transform"], Ga = ["x", "y", "font-size", "fill"], va = { key: 9 }, pa = ["text-anchor", "font-size", "fill", "transform", "onClick"], za = ["x", "y", "height", "width", "onMouseenter", "onClick"], Ma = { key: 10 }, Ta = ["x", "y"], Pa = ["cx", "cy", "r", "fill"], Va = {
  key: 5,
  class: "vue-data-ui-watermark"
}, Ra = ["onClick"], Da = {
  key: 0,
  viewBox: "0 0 20 12",
  height: "14",
  width: "20"
}, Ba = ["stroke", "fill"], Ea = {
  key: 1,
  viewBox: "0 0 12 12",
  height: "14",
  width: "14"
}, Ha = ["fill"], Wa = {
  key: 9,
  ref: "chartLegend"
}, Ya = {
  key: 10,
  ref: "source",
  dir: "auto"
}, Xa = {
  style: { display: "flex", "flex-direction": "row", gap: "6px", "align-items": "center", "padding-left": "6px" },
  "data-html2canvas-ignore": ""
}, qa = ["innerHTML"];
function Ua(a, s, o, u, t, e) {
  const x = P("PenAndPaper"), A = P("Title"), k = P("UserOptions"), N = P("PackageVersion"), F = P("Shape"), T = P("Skeleton"), v = P("Slicer"), p = P("Tooltip"), O = P("BaseIcon"), _ = P("TableSparkline"), C = P("DataTable"), z = P("Accordion");
  return r(), l("div", {
    id: `vue-ui-xy_${t.uniqueId}`,
    class: V(`vue-ui-xy ${t.isFullscreen ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.FINAL_CONFIG.useCssAnimation ? "" : "vue-ui-dna"}`),
    ref: "chart",
    style: L(`background:${e.FINAL_CONFIG.chart.backgroundColor}; color:${e.FINAL_CONFIG.chart.color};width:100%;font-family:${e.FINAL_CONFIG.chart.fontFamily};${e.FINAL_CONFIG.responsive ? "height: 100%" : ""}`)
  }, [
    e.FINAL_CONFIG.chart.userOptions.buttons.annotator ? (r(), D(x, {
      key: 0,
      parent: a.$refs.chart,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      active: t.isAnnotator,
      onClose: e.toggleAnnotator
    }, null, 8, ["parent", "backgroundColor", "color", "active", "onClose"])) : c("", !0),
    e.hasOptionsNoTitle ? (r(), l("div", Ze, null, 512)) : c("", !0),
    e.FINAL_CONFIG.chart.title.show ? (r(), l("div", {
      key: 2,
      ref: "chartTitle",
      class: "vue-ui-xy-title",
      style: L(`font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      (r(), D(A, {
        key: `title_${t.titleStep}`,
        config: {
          title: {
            cy: "xy-div-title",
            ...e.FINAL_CONFIG.chart.title
          },
          subtitle: {
            cy: "xy-div-subtitle",
            ...e.FINAL_CONFIG.chart.title.subtitle
          }
        }
      }, null, 8, ["config"]))
    ], 4)) : c("", !0),
    e.FINAL_CONFIG.chart.userOptions.show && e.isDataset ? (r(), D(k, {
      ref: "defails",
      key: `user_options_${t.step}`,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      isPrinting: t.isPrinting,
      isImaging: t.isImaging,
      uid: t.uniqueId,
      hasTooltip: e.FINAL_CONFIG.chart.userOptions.buttons.tooltip && e.FINAL_CONFIG.chart.tooltip.show,
      hasPdf: e.FINAL_CONFIG.chart.userOptions.buttons.pdf,
      hasXls: e.FINAL_CONFIG.chart.userOptions.buttons.csv,
      hasImg: e.FINAL_CONFIG.chart.userOptions.buttons.img,
      hasLabel: e.FINAL_CONFIG.chart.userOptions.buttons.labels,
      hasTable: e.FINAL_CONFIG.chart.userOptions.buttons.table,
      hasStack: o.dataset.length > 1 && e.FINAL_CONFIG.chart.userOptions.buttons.stack,
      hasFullscreen: e.FINAL_CONFIG.chart.userOptions.buttons.fullscreen,
      isStacked: t.mutableConfig.isStacked,
      isFullscreen: t.isFullscreen,
      chartElement: a.$refs.chart,
      position: e.FINAL_CONFIG.chart.userOptions.position,
      isTooltip: t.mutableConfig.showTooltip,
      titles: { ...e.FINAL_CONFIG.chart.userOptions.buttonTitles },
      hasAnnotator: e.FINAL_CONFIG.chart.userOptions.buttons.annotator,
      isAnnotation: t.isAnnotator,
      onToggleFullscreen: e.toggleFullscreen,
      onGeneratePdf: e.generatePdf,
      onGenerateCsv: e.generateCsv,
      onGenerateImage: e.generateImage,
      onToggleTable: e.toggleTable,
      onToggleLabels: e.toggleLabels,
      onToggleStack: e.toggleStack,
      onToggleTooltip: e.toggleTooltip,
      onToggleAnnotator: e.toggleAnnotator
    }, Be({ _: 2 }, [
      a.$slots.optionTooltip ? {
        name: "optionTooltip",
        fn: M(() => [
          w(a.$slots, "optionTooltip", {}, void 0, !0)
        ]),
        key: "0"
      } : void 0,
      a.$slots.optionPdf ? {
        name: "optionPdf",
        fn: M(() => [
          w(a.$slots, "optionPdf", {}, void 0, !0)
        ]),
        key: "1"
      } : void 0,
      a.$slots.optionCsv ? {
        name: "optionCsv",
        fn: M(() => [
          w(a.$slots, "optionCsv", {}, void 0, !0)
        ]),
        key: "2"
      } : void 0,
      a.$slots.optionImg ? {
        name: "optionImg",
        fn: M(() => [
          w(a.$slots, "optionImg", {}, void 0, !0)
        ]),
        key: "3"
      } : void 0,
      a.$slots.optionTable ? {
        name: "optionTable",
        fn: M(() => [
          w(a.$slots, "optionTable", {}, void 0, !0)
        ]),
        key: "4"
      } : void 0,
      a.$slots.optionLabels ? {
        name: "optionLabels",
        fn: M(() => [
          w(a.$slots, "optionLabels", {}, void 0, !0)
        ]),
        key: "5"
      } : void 0,
      a.$slots.optionStack ? {
        name: "optionStack",
        fn: M(() => [
          w(a.$slots, "optionStack", {}, void 0, !0)
        ]),
        key: "6"
      } : void 0,
      a.$slots.optionFullscreen ? {
        name: "optionFullscreen",
        fn: M(({ toggleFullscreen: i, isFullscreen: h }) => [
          w(a.$slots, "optionFullscreen", B(E({ toggleFullscreen: i, isFullscreen: h })), void 0, !0)
        ]),
        key: "7"
      } : void 0,
      a.$slots.optionAnnotator ? {
        name: "optionAnnotator",
        fn: M(({ toggleAnnotator: i, isAnnotator: h }) => [
          w(a.$slots, "optionAnnotator", B(E({ toggleAnnotator: i, isAnnotator: h })), void 0, !0)
        ]),
        key: "8"
      } : void 0
    ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasLabel", "hasTable", "hasStack", "hasFullscreen", "isStacked", "isFullscreen", "chartElement", "position", "isTooltip", "titles", "hasAnnotator", "isAnnotation", "onToggleFullscreen", "onGeneratePdf", "onGenerateCsv", "onGenerateImage", "onToggleTable", "onToggleLabels", "onToggleStack", "onToggleTooltip", "onToggleAnnotator"])) : c("", !0),
    e.isDataset ? (r(), l("svg", {
      key: 4,
      xmlns: "http://www.w3.org/2000/svg",
      class: V([{ "vue-data-ui-fullscreen--on": t.isFullscreen, "vue-data-ui-fulscreen--off": !t.isFullscreen }, "vue-ui-xy-svg"]),
      width: "100%",
      viewBox: t.viewBox,
      style: L(`background: transparent; color:${e.FINAL_CONFIG.chart.color}; font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      X(N),
      e.maxSeries > 0 ? (r(), l("g", Ke, [
        f("g", Qe, [
          e.FINAL_CONFIG.chart.grid.labels.xAxis.showBaseline ? (r(), l("line", {
            key: 0,
            stroke: e.FINAL_CONFIG.chart.grid.stroke,
            "stroke-width": "1",
            x1: e.drawingArea.left + e.xPadding,
            x2: e.drawingArea.right - e.xPadding,
            y1: e.drawingArea.bottom,
            y2: e.drawingArea.bottom,
            "stroke-linecap": "round"
          }, null, 8, je)) : c("", !0),
          t.mutableConfig.useIndividualScale ? e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (r(!0), l(I, { key: 2 }, m(e.allScales, (i) => (r(), l("g", null, [
            i.id === t.selectedScale && i.yLabels.length ? (r(!0), l(I, { key: 0 }, m(i.yLabels, (h) => (r(), l("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.checkNaN(h.y),
              y2: e.checkNaN(h.y),
              stroke: i.color,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, at))), 256)) : i.yLabels.length ? (r(!0), l(I, { key: 1 }, m(i.yLabels, (h) => (r(), l("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.checkNaN(h.y),
              y2: e.checkNaN(h.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, it))), 256)) : c("", !0)
          ]))), 256)) : c("", !0) : (r(), l(I, { key: 1 }, [
            e.FINAL_CONFIG.chart.grid.labels.yAxis.showBaseline ? (r(), l("line", {
              key: 0,
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left + e.xPadding,
              y1: e.drawingArea.top,
              y2: e.drawingArea.bottom,
              "stroke-linecap": "round"
            }, null, 8, $e)) : c("", !0),
            e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (r(), l("g", et, [
              (r(!0), l(I, null, m(e.yLabels, (i) => (r(), l("line", {
                x1: e.drawingArea.left + e.xPadding,
                x2: e.drawingArea.right - e.xPadding,
                y1: e.checkNaN(i.y),
                y2: e.checkNaN(i.y),
                stroke: e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-width": 0.5,
                "stroke-linecap": "round"
              }, null, 8, tt))), 256))
            ])) : c("", !0)
          ], 64)),
          e.FINAL_CONFIG.chart.grid.showVerticalLines ? (r(), l("g", rt, [
            (r(!0), l(I, null, m(e.maxSeries + (e.FINAL_CONFIG.chart.grid.position === "middle" ? 1 : 0), (i, h) => (r(), l("line", {
              key: `grid_vertical_line_${h}`,
              x1: e.drawingArea.width / e.maxSeries * h + e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.width / e.maxSeries * h + e.drawingArea.left + e.xPadding,
              y1: e.drawingArea.top,
              y2: e.drawingArea.bottom,
              "stroke-width": "0.5",
              stroke: e.FINAL_CONFIG.chart.grid.stroke
            }, null, 8, lt))), 128))
          ])) : c("", !0)
        ]),
        (r(!0), l(I, null, m(e.barSet, (i, h) => (r(), l("defs", {
          key: `def_rect_${h}`
        }, [
          f("linearGradient", {
            id: `rectGradient_pos_${h}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": i.color
            }, null, 8, nt),
            f("stop", {
              offset: "62%",
              "stop-color": `${e.shiftHue(i.color, 0.02)}`
            }, null, 8, ht),
            f("stop", {
              offset: "100%",
              "stop-color": `${e.shiftHue(i.color, 0.05)}`
            }, null, 8, ot)
          ], 8, st),
          f("linearGradient", {
            id: `rectGradient_neg_${h}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(i.color, 0.05)}`
            }, null, 8, dt),
            f("stop", {
              offset: "38%",
              "stop-color": `${e.shiftHue(i.color, 0.02)}`
            }, null, 8, ut),
            f("stop", {
              offset: "100%",
              "stop-color": i.color
            }, null, 8, gt)
          ], 8, ct)
        ]))), 128)),
        (r(!0), l(I, null, m(e.plotSet, (i, h) => (r(), l("defs", {
          key: `def_plot_${h}`
        }, [
          f("radialGradient", {
            id: `plotGradient_${h}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(i.color, 0.05)}`
            }, null, 8, It),
            f("stop", {
              offset: "100%",
              "stop-color": i.color
            }, null, 8, Nt)
          ], 8, ft)
        ]))), 128)),
        (r(!0), l(I, null, m(e.lineSet, (i, h) => (r(), l("defs", {
          key: `def_line_${h}`
        }, [
          f("radialGradient", {
            id: `lineGradient_${h}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(i.color, 0.05)}`
            }, null, 8, xt),
            f("stop", {
              offset: "100%",
              "stop-color": i.color
            }, null, 8, Ft)
          ], 8, mt),
          f("linearGradient", {
            id: `areaGradient_${h}_${t.uniqueId}`,
            x1: "0%",
            x2: "100%",
            y1: "0%",
            y2: "0%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": `${e.setOpacity(e.shiftHue(i.color, 0.03), e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, _t),
            f("stop", {
              offset: "100%",
              "stop-color": `${e.setOpacity(i.color, e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, At)
          ], 8, bt)
        ]))), 128)),
        (r(!0), l(I, null, m(e.highlightAreas, (i) => (r(), l("g", null, [
          i.show ? (r(!0), l(I, { key: 0 }, m(i.span, (h, n) => (r(), l("g", null, [
            f("rect", {
              style: L({
                transition: "none",
                opacity: i.from + n >= t.slicer.start && i.from + n <= t.slicer.end - 1 ? 1 : 0
              }),
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (i.from + n - t.slicer.start),
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: e.setOpacity(i.color, i.opacity)
            }, null, 12, yt),
            i.caption.text && n === 0 ? (r(), l("foreignObject", {
              key: 0,
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (i.from + n - t.slicer.start) - (i.caption.width === "auto" ? 0 : i.caption.width / 2 - e.drawingArea.width / e.maxSeries * i.span / 2),
              y: e.drawingArea.top + i.caption.offsetY,
              style: L({
                overflow: "visible",
                opacity: i.to >= t.slicer.start && i.from < t.slicer.end ? 1 : 0
              }),
              height: "1",
              width: i.caption.width === "auto" ? e.drawingArea.width / e.maxSeries * i.span : i.caption.width
            }, [
              f("div", {
                style: L(`padding:${i.caption.padding}px;text-align:${i.caption.textAlign};font-size:${i.caption.fontSize}px;color:${i.caption.color};font-weight:${i.caption.bold ? "bold" : "normal"}`)
              }, S(i.caption.text), 5)
            ], 12, Lt)) : c("", !0)
          ]))), 256)) : c("", !0)
        ]))), 256)),
        f("g", null, [
          (r(!0), l(I, null, m(e.maxSeries, (i, h) => (r(), l("g", {
            key: `tooltip_trap_highlighter_${h}`
          }, [
            f("rect", {
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * h,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: [t.selectedMinimapIndex, t.selectedSerieIndex, t.selectedRowIndex].includes(h) ? e.setOpacity(e.FINAL_CONFIG.chart.highlighter.color, e.FINAL_CONFIG.chart.highlighter.opacity) : "transparent"
            }, null, 8, Ct)
          ]))), 128))
        ]),
        e.barSet.length ? (r(!0), l(I, { key: 0 }, m(e.barSet, (i, h) => (r(), l("g", {
          key: `serie_bar_${h}`,
          class: V(`serie_bar_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(I, null, m(i.plots, (n, d) => (r(), l("g", {
            key: `bar_plot_${h}_${d}`
          }, [
            e.canShowValue(n.value) ? (r(), l("rect", {
              key: 0,
              x: e.calcRectX(n),
              y: t.mutableConfig.useIndividualScale ? e.calcIndividualRectY(n) : e.calcRectY(n),
              height: t.mutableConfig.useIndividualScale ? Math.abs(e.calcIndividualHeight(n)) : Math.abs(e.calcRectHeight(n)),
              width: e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap),
              rx: e.FINAL_CONFIG.bar.borderRadius,
              fill: e.FINAL_CONFIG.bar.useGradient ? n.value >= 0 ? `url(#rectGradient_pos_${h}_${t.uniqueId})` : `url(#rectGradient_neg_${h}_${t.uniqueId})` : i.color,
              stroke: e.FINAL_CONFIG.bar.border.useSerieColor ? i.color : e.FINAL_CONFIG.bar.border.stroke,
              "stroke-width": e.FINAL_CONFIG.bar.border.strokeWidth
            }, null, 8, St)) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (r(), l("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: (e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) / 2) + e.FINAL_CONFIG.chart.comments.width,
              x: e.calcRectX(n) - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: e.checkNaN(n.y) + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              w(a.$slots, "plot-comment", {
                plot: { ...n, color: i.color, seriesIndex: h, datapointIndex: d }
              }, void 0, !0)
            ], 8, kt)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(i, "useProgression") && i.useProgression === !0 && !isNaN(e.calcLinearProgression(i.plots).trend) ? (r(), l("g", wt, [
            f("defs", null, [
              f("marker", {
                id: `bar_arrow_${h}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                f("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: i.color
                }, null, 8, Gt)
              ], 8, Ot)
            ]),
            i.plots.length > 1 ? (r(), l("line", {
              key: 0,
              x1: e.calcLinearProgression(i.plots).x1,
              x2: e.calcLinearProgression(i.plots).x2,
              y1: e.calcLinearProgression(i.plots).y1,
              y2: e.calcLinearProgression(i.plots).y2,
              "stroke-width": 1,
              stroke: i.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#bar_arrow_${h})`
            }, null, 8, vt)) : c("", !0),
            i.plots.length > 1 ? (r(), l("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(i.plots).x2,
              y: e.calcLinearProgression(i.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: i.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(i.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, pt)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)) : c("", !0),
        !t.mutableConfig.useIndividualScale && e.FINAL_CONFIG.chart.grid.labels.zeroLine.show ? (r(), l("line", {
          key: 1,
          stroke: e.FINAL_CONFIG.chart.grid.stroke,
          "stroke-width": "1",
          x1: e.drawingArea.left + e.xPadding,
          x2: e.drawingArea.right - e.xPadding,
          y1: e.checkNaN(e.zero),
          y2: e.checkNaN(e.zero),
          "stroke-linecap": "round"
        }, null, 8, zt)) : c("", !0),
        e.FINAL_CONFIG.chart.highlighter.useLine && (![null, void 0].includes(t.selectedSerieIndex) || ![null, void 0].includes(t.selectedMinimapIndex)) ? (r(), l("g", Mt, [
          f("line", {
            x1: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            x2: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            y1: e.drawingArea.top,
            y2: e.drawingArea.bottom,
            stroke: e.FINAL_CONFIG.chart.highlighter.color,
            "stroke-width": e.FINAL_CONFIG.chart.highlighter.lineWidth,
            "stroke-dasharray": e.FINAL_CONFIG.chart.highlighter.lineDasharray,
            "stroke-linecap": "round",
            style: { transition: "none !important", animation: "none !important", "pointer-events": "none" }
          }, null, 8, Tt)
        ])) : c("", !0),
        e.FINAL_CONFIG.chart.grid.frame.show ? (r(), l("rect", {
          key: 3,
          style: { pointerEvents: "none", transition: "none" },
          x: e.drawingArea.left + e.xPadding < 0 ? 0 : e.drawingArea.left + e.xPadding,
          y: e.drawingArea.top,
          width: e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries) < 0 ? 0 : e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries),
          height: e.drawingArea.height < 0 ? 0 : e.drawingArea.height,
          fill: "transparent",
          stroke: e.FINAL_CONFIG.chart.grid.frame.stroke,
          "stroke-width": e.FINAL_CONFIG.chart.grid.frame.strokeWidth,
          "stroke-linecap": e.FINAL_CONFIG.chart.grid.frame.strokeLinecap,
          "stroke-linejoin": e.FINAL_CONFIG.chart.grid.frame.strokeLinejoin,
          "stroke-dasharray": e.FINAL_CONFIG.chart.grid.frame.strokeDasharray
        }, null, 8, Pt)) : c("", !0),
        e.FINAL_CONFIG.chart.grid.labels.show ? (r(), l("g", Vt, [
          t.mutableConfig.useIndividualScale ? (r(), l(I, { key: 0 }, [
            (r(!0), l(I, null, m(e.allScales, (i) => (r(), l("g", null, [
              f("line", {
                x1: i.x + e.xPadding,
                x2: i.x + e.xPadding,
                y1: t.mutableConfig.isStacked ? e.checkNaN(e.drawingArea.bottom - i.yOffset - i.individualHeight) : e.checkNaN(e.drawingArea.top),
                y2: t.mutableConfig.isStacked ? e.checkNaN(e.drawingArea.bottom - i.yOffset) : e.checkNaN(e.drawingArea.bottom),
                stroke: i.color,
                "stroke-width": e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-linecap": "round",
                style: L(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
              }, null, 12, Rt)
            ]))), 256)),
            (r(!0), l(I, null, m(e.allScales, (i) => (r(), l("g", {
              style: L(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
            }, [
              f("text", {
                fill: i.color,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "middle",
                transform: `translate(${i.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth + 5}, ${t.mutableConfig.isStacked ? e.drawingArea.bottom - i.yOffset - i.individualHeight / 2 : e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`
              }, S(i.name) + " " + S(i.scaleLabel ? `- ${i.scaleLabel}` : ""), 9, Dt),
              (r(!0), l(I, null, m(i.yLabels, (h, n) => (r(), l("line", {
                x1: i.x - 3 + e.xPadding,
                x2: i.x + e.xPadding,
                y1: e.checkNaN(h.y),
                y2: e.checkNaN(h.y),
                stroke: i.color,
                "stroke-width": 1,
                "stroke-linecap": "round"
              }, null, 8, Bt))), 256)),
              (r(!0), l(I, null, m(i.yLabels, (h, n) => (r(), l("text", {
                x: i.x - 5 + e.xPadding,
                y: e.checkNaN(h.y) + t.fontSizes.dataLabels / 3,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "end",
                fill: i.color
              }, S(e.applyDataLabel(
                e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
                h.value,
                e.dataLabel({
                  p: h.prefix,
                  v: h.value,
                  s: h.suffix,
                  r: 1
                }),
                { datapoint: h.datapoint, seriesIndex: n }
              )), 9, Et))), 256))
            ], 4))), 256))
          ], 64)) : (r(!0), l(I, { key: 1 }, m(e.yLabels, (i, h) => (r(), l("g", {
            key: `yLabel_${h}`
          }, [
            e.canShowValue(i) && i.value >= e.niceScale.min && i.value <= e.niceScale.max ? (r(), l("line", {
              key: 0,
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left - 5 + e.xPadding,
              y1: e.checkNaN(i.y),
              y2: e.checkNaN(i.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              "stroke-linecap": "round"
            }, null, 8, Ht)) : c("", !0),
            i.value >= e.niceScale.min && i.value <= e.niceScale.max ? (r(), l("text", {
              key: 1,
              x: e.drawingArea.left - 7 + e.xPadding,
              y: e.checkNaN(i.y + t.fontSizes.dataLabels / 3),
              "font-size": t.fontSizes.dataLabels,
              "text-anchor": "end",
              fill: e.FINAL_CONFIG.chart.grid.labels.color
            }, S(e.canShowValue(i.value) ? e.applyDataLabel(
              e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
              i.value,
              e.dataLabel({
                p: i.prefix,
                v: i.value,
                s: i.suffix,
                r: 1
              })
            ) : ""), 9, Wt)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        (r(!0), l(I, null, m(e.plotSet, (i, h) => (r(), l("g", {
          key: `serie_plot_${h}`,
          class: V(`serie_plot_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(I, null, m(i.plots, (n, d) => (r(), l("g", {
            key: `circle_plot_${h}_${d}`
          }, [
            n && e.canShowValue(n.value) ? (r(), D(F, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(i.shape) ? i.shape : "circle",
              color: e.FINAL_CONFIG.plot.useGradient ? `url(#plotGradient_${h}_${t.uniqueId})` : e.FINAL_CONFIG.plot.dot.useSerieColor ? i.color : e.FINAL_CONFIG.plot.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (t.plotRadii.plot || 6) * 1.5 : t.plotRadii.plot || 6,
              stroke: e.FINAL_CONFIG.plot.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : i.color,
              strokeWidth: e.FINAL_CONFIG.plot.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (r(), l("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              f("div", Xt, [
                w(a.$slots, "plot-comment", {
                  plot: { ...n, color: i.color, seriesIndex: h, datapointIndex: d }
                }, void 0, !0)
              ])
            ], 8, Yt)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(i, "useProgression") && i.useProgression === !0 && !isNaN(e.calcLinearProgression(i.plots).trend) ? (r(), l("g", qt, [
            f("defs", null, [
              f("marker", {
                id: `plot_arrow_${h}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                f("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: i.color
                }, null, 8, Zt)
              ], 8, Ut)
            ]),
            i.plots.length > 1 ? (r(), l("line", {
              key: 0,
              x1: e.calcLinearProgression(i.plots).x1,
              x2: e.calcLinearProgression(i.plots).x2,
              y1: e.calcLinearProgression(i.plots).y1,
              y2: e.calcLinearProgression(i.plots).y2,
              "stroke-width": 1,
              stroke: i.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#plot_arrow_${h})`
            }, null, 8, Jt)) : c("", !0),
            i.plots.length > 1 ? (r(), l("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(i.plots).x2,
              y: e.calcLinearProgression(i.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: i.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(i.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, Kt)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (r(!0), l(I, null, m(e.lineSet, (i, h) => (r(), l("g", {
          key: `serie_line_${h}`,
          class: V(`serie_line_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          i.smooth && i.plots.length > 1 ? (r(), l("path", {
            key: 0,
            d: `M${i.curve}`,
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
            "stroke-dasharray": i.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, Qt)) : i.plots.length > 1 ? (r(), l("g", jt, [
            (r(!0), l(I, null, m(i.plots, (n, d) => (r(), l("g", {
              key: `line_${h}_${d}`
            }, [
              n && d < i.plots.length - 1 && i.plots[d + 1] && e.canShowValue(n.value) && e.canShowValue(i.plots[d + 1].value) ? (r(), l("line", {
                key: 0,
                x1: n.x,
                x2: i.plots[d + 1].x,
                y1: n.y,
                y2: i.plots[d + 1].y,
                stroke: e.FINAL_CONFIG.chart.backgroundColor,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
                "stroke-dasharray": i.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, $t)) : c("", !0)
            ]))), 128))
          ])) : c("", !0)
        ], 6))), 128)),
        (r(!0), l(I, null, m(e.lineSet, (i, h) => (r(), l("g", {
          key: `serie_line_${h}`,
          class: V(`serie_line_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          i.useArea && i.plots.length > 1 ? (r(), l("g", ea, [
            i.smooth ? (r(), l("path", {
              key: 0,
              d: `M ${i.plots[0] ? i.plots[0].x : Math.min(...i.plots.filter((n) => !!n).map((n) => n.x))},${t.mutableConfig.isStacked ? e.drawingArea.bottom - i.yOffset : e.drawingArea.bottom} ${i.curve} L ${i.plots.at(-1) ? i.plots.at(-1).x : e.drawingArea.left + e.slot.line * h + e.slot.line / 2},${t.mutableConfig.isStacked ? e.drawingArea.bottom - i.yOffset : e.drawingArea.bottom} Z`,
              fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${h}_${t.uniqueId})` : e.setOpacity(i.color, e.FINAL_CONFIG.line.area.opacity)
            }, null, 8, ta)) : (r(), l("path", {
              key: 1,
              d: `M${i.area}Z`,
              fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${h}_${t.uniqueId})` : e.setOpacity(i.color, e.FINAL_CONFIG.line.area.opacity)
            }, null, 8, aa))
          ])) : c("", !0),
          i.smooth && i.plots.length > 1 ? (r(), l("path", {
            key: 1,
            d: `M${i.curve}`,
            stroke: i.color,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
            "stroke-dasharray": i.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, ia)) : i.plots.length > 1 ? (r(), l("g", ra, [
            (r(!0), l(I, null, m(i.plots, (n, d) => (r(), l("g", {
              key: `line_${h}_${d}`
            }, [
              n && d < i.plots.length - 1 && i.plots[d + 1] && e.canShowValue(n.value) && e.canShowValue(i.plots[d + 1].value) ? (r(), l("line", {
                key: 0,
                x1: n.x,
                x2: i.plots[d + 1].x,
                y1: n.y,
                y2: i.plots[d + 1].y,
                stroke: i.color,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
                "stroke-dasharray": i.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, la)) : c("", !0)
            ]))), 128))
          ])) : c("", !0),
          (r(!0), l(I, null, m(i.plots, (n, d) => (r(), l("g", {
            key: `circle_line_${h}_${d}`
          }, [
            n && e.canShowValue(n.value) ? (r(), D(F, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(i.shape) ? i.shape : "circle",
              color: e.FINAL_CONFIG.line.useGradient ? `url(#lineGradient_${h}_${t.uniqueId})` : e.FINAL_CONFIG.line.dot.useSerieColor ? i.color : e.FINAL_CONFIG.line.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (t.plotRadii.line || 6) * 1.5 : t.plotRadii.line || 6,
              stroke: e.FINAL_CONFIG.line.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : i.color,
              strokeWidth: e.FINAL_CONFIG.line.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (r(), l("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              f("div", na, [
                w(a.$slots, "plot-comment", {
                  plot: { ...n, color: i.color, seriesIndex: h, datapointIndex: d }
                }, void 0, !0)
              ])
            ], 8, sa)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(i, "useProgression") && i.useProgression === !0 && !isNaN(e.calcLinearProgression(i.plots).trend) ? (r(), l("g", ha, [
            f("defs", null, [
              f("marker", {
                id: `line_arrow_${h}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                f("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: i.color
                }, null, 8, ca)
              ], 8, oa)
            ]),
            i.plots.length > 1 ? (r(), l("line", {
              key: 0,
              x1: e.calcLinearProgression(i.plots).x1,
              x2: e.calcLinearProgression(i.plots).x2,
              y1: e.calcLinearProgression(i.plots).y1,
              y2: e.calcLinearProgression(i.plots).y2,
              "stroke-width": 1,
              stroke: i.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#line_arrow_${h})`
            }, null, 8, da)) : c("", !0),
            i.plots.length > 1 ? (r(), l("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(i.plots).x2,
              y: e.calcLinearProgression(i.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: i.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(i.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, ua)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (e.FINAL_CONFIG.bar.labels.show || e.FINAL_CONFIG.bar.serieName.show) && t.mutableConfig.dataLabels.show ? (r(), l("g", ga, [
          (r(!0), l(I, null, m(e.barSet, (i, h) => (r(), l("g", {
            key: `xLabel_bar_${h}`,
            class: V(`xLabel_bar_${h}`),
            style: L(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (r(!0), l(I, null, m(i.plots, (n, d) => (r(), l("g", {
              key: `xLabel_bar_${h}_${d}`
            }, [
              n && (!Object.hasOwn(i, "dataLabels") || i.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d) && e.FINAL_CONFIG.bar.labels.show ? (r(), l("text", {
                key: 0,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : e.calcRectX(n) + e.calcRectWidth() / 2 - e.barPeriodGap / 2,
                y: e.checkNaN(n.y) + (n.value >= 0 ? e.FINAL_CONFIG.bar.labels.offsetY : -e.FINAL_CONFIG.bar.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.bar.labels.formatter,
                n.value,
                e.dataLabel({
                  p: i.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: i.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.bar.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: i
                }
              ) : ""), 9, fa)) : c("", !0),
              n && e.FINAL_CONFIG.bar.serieName.show ? (r(), l("text", {
                key: 1,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : n.x + e.calcRectWidth() * 1.1,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.bar.serieName.offsetY : -e.FINAL_CONFIG.bar.serieName.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.serieName.useSerieColor ? i.color : e.FINAL_CONFIG.bar.serieName.color,
                "font-weight": e.FINAL_CONFIG.bar.serieName.bold ? "bold" : "normal"
              }, S(e.FINAL_CONFIG.bar.serieName.useAbbreviation ? e.abbreviate({ source: i.name, length: e.FINAL_CONFIG.bar.serieName.abbreviationSize }) : i.name), 9, Ia)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.plot.labels.show && t.mutableConfig.dataLabels.show ? (r(), l("g", Na, [
          (r(!0), l(I, null, m(e.plotSet, (i, h) => (r(), l("g", {
            key: `xLabel_plot_${h}`,
            class: V(`xLabel_plot_${h}`),
            style: L(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (r(!0), l(I, null, m(i.plots, (n, d) => (r(), l("g", {
              key: `xLabel_plot_${h}_${d}`
            }, [
              n && !Object.hasOwn(i, "dataLabels") || i.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (r(), l("text", {
                key: 0,
                x: n.x,
                y: n.y + e.FINAL_CONFIG.plot.labels.offsetY,
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.plot.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.plot.labels.formatter,
                n.value,
                e.dataLabel({
                  p: i.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: i.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.plot.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: i
                }
              ) : ""), 9, ma)) : c("", !0),
              n && d === 0 && i.useTag && i.useTag === "start" ? (r(), l("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                f("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(i.color, 80)};color:${e.adaptColorToBackground(i.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(i.name), 5)
              ], 8, xa)) : c("", !0),
              n && d === i.plots.length - 1 && i.useTag && i.useTag === "end" ? (r(), l("foreignObject", {
                key: 2,
                x: n.x - i.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                f("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(i.color, 80)};color:${e.adaptColorToBackground(i.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(i.name), 5)
              ], 8, Fa)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.line.labels.show && t.mutableConfig.dataLabels.show ? (r(), l("g", ba, [
          (r(!0), l(I, null, m(e.lineSet, (i, h) => (r(), l("g", {
            key: `xLabel_line_${h}`,
            class: V(`xLabel_line_${h}`),
            style: L(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (r(!0), l(I, null, m(i.plots, (n, d) => (r(), l("g", {
              key: `xLabel_line_${h}_${d}`
            }, [
              n && !Object.hasOwn(i, "dataLabels") || i.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (r(), l("text", {
                key: 0,
                x: n.x,
                y: n.y + (n.value >= 0 ? e.FINAL_CONFIG.line.labels.offsetY : -e.FINAL_CONFIG.line.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.line.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.line.labels.formatter,
                n.value,
                e.dataLabel({
                  p: i.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: i.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.line.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: i
                }
              ) : ""), 9, _a)) : c("", !0),
              n && d === 0 && i.useTag && i.useTag === "start" ? (r(), l("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                f("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(i.color, 80)};color:${e.adaptColorToBackground(i.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(i.name), 5)
              ], 8, Aa)) : c("", !0),
              n && d === i.plots.length - 1 && i.useTag && i.useTag === "end" ? (r(), l("foreignObject", {
                key: 2,
                x: n.x - i.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                f("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(i.color, 80)};color:${e.adaptColorToBackground(i.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(i.name), 5)
              ], 8, ya)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        (r(!0), l(I, null, m(e.lineSet, (i, h) => (r(), l("g", {
          key: `xLabel_line_${h}`,
          class: V(`xLabel_line_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(I, null, m(i.plots, (n, d) => (r(), l("g", {
            key: `xLabel_line_${h}_${d}`
          }, [
            n && d === 0 && i.showSerieName && i.showSerieName === "start" ? (r(), l("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: i.color,
              innerHTML: e.createTSpans({
                content: i.name,
                fontSize: t.fontSizes.plotLabels,
                fill: i.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, La)) : c("", !0),
            n && d === i.plots.length - 1 && i.showSerieName && i.showSerieName === "end" ? (r(), l("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: i.color,
              innerHTML: e.createTSpans({
                content: i.name,
                fontSize: t.fontSizes.plotLabels,
                fill: i.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Ca)) : c("", !0)
          ]))), 128))
        ], 6))), 128)),
        (r(!0), l(I, null, m(e.plotSet, (i, h) => (r(), l("g", {
          key: `xLabel_plot_${h}`,
          class: V(`xLabel_plot_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(I, null, m(i.plots, (n, d) => (r(), l("g", {
            key: `xLabel_plot_${h}_${d}`
          }, [
            n && d === 0 && i.showSerieName && i.showSerieName === "start" ? (r(), l("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: i.color,
              innerHTML: e.createTSpans({
                content: i.name,
                fontSize: t.fontSizes.plotLabels,
                fill: i.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Sa)) : c("", !0),
            n && d === i.plots.length - 1 && i.showSerieName && i.showSerieName === "end" ? (r(), l("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: i.color,
              innerHTML: e.createTSpans({
                content: i.name,
                fontSize: t.fontSizes.plotLabels,
                fill: i.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, ka)) : c("", !0)
          ]))), 128))
        ], 6))), 128)),
        t.mutableConfig.useIndividualScale && !t.mutableConfig.isStacked ? (r(!0), l(I, { key: 8 }, m(e.allScales, (i) => (r(), l("rect", {
          x: i.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          y: e.drawingArea.top,
          width: e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
          fill: t.selectedScale === i.id ? e.setOpacity(i.color, 20) : "transparent",
          onMouseenter: (h) => t.selectedScale = i.id,
          onMouseleave: s[0] || (s[0] = (h) => t.selectedScale = null)
        }, null, 40, wa))), 256)) : c("", !0),
        f("g", null, [
          e.FINAL_CONFIG.chart.grid.labels.axis.yLabel && !t.mutableConfig.useIndividualScale ? (r(), l("text", {
            key: 0,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color,
            transform: `translate(${t.fontSizes.yAxis + e.FINAL_CONFIG.chart.grid.labels.axis.yLabelOffsetX}, ${e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`,
            "text-anchor": "middle",
            style: { transition: "none" }
          }, S(e.FINAL_CONFIG.chart.grid.labels.axis.yLabel), 9, Oa)) : c("", !0),
          e.FINAL_CONFIG.chart.grid.labels.axis.xLabel ? (r(), l("text", {
            key: 1,
            "text-anchor": "middle",
            x: t.width / 2,
            y: e.drawingArea.bottom + t.fontSizes.yAxis + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.axis.xLabelOffsetY,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color
          }, S(e.FINAL_CONFIG.chart.grid.labels.axis.xLabel), 9, Ga)) : c("", !0)
        ]),
        e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.show ? (r(), l("g", va, [
          a.$slots["time-label"] ? (r(!0), l(I, { key: 0 }, m(e.timeLabels, (i, h) => (r(), l("g", {
            key: `time_label_${h}`
          }, [
            w(a.$slots, "time-label", B(E({
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * h + e.drawingArea.width / e.maxSeries / 2,
              y: e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset,
              fontSize: t.fontSizes.xAxis,
              fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
              transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * h + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`,
              absoluteIndex: i.absoluteIndex,
              content: i.text,
              textAnchor: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
              show: i && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || i && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (h === 0 || h === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || i && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && t.selectedSerieIndex === h && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || i && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && h % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0
            })), void 0, !0)
          ]))), 128)) : (r(!0), l(I, { key: 1 }, m(e.timeLabels, (i, h) => (r(), l("g", {
            key: `time_label_${h}`
          }, [
            i && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || i && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (h === 0 || h === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || i && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && t.selectedSerieIndex === h && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || i && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && h % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0 ? (r(), l("text", {
              key: 0,
              "text-anchor": e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
              "font-size": t.fontSizes.xAxis,
              fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
              transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * h + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`,
              style: {
                cursor: "pointer"
              },
              onClick: () => e.selectTimeLabel(i, h)
            }, S(i.text || ""), 9, pa)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        f("g", null, [
          (r(!0), l(I, null, m(e.maxSeries, (i, h) => (r(), l("g", {
            key: `tooltip_trap_${h}`
          }, [
            f("rect", {
              "data-cy-trap": "",
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * h,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: "transparent",
              onMouseenter: (n) => e.toggleTooltipVisibility(!0, h),
              onMouseleave: s[1] || (s[1] = (n) => e.toggleTooltipVisibility(!1)),
              onClick: (n) => e.selectX(h)
            }, null, 40, za)
          ]))), 128))
        ]),
        e.FINAL_CONFIG.chart.timeTag.show && (![null, void 0].includes(t.selectedSerieIndex) || ![null, void 0].includes(t.selectedMinimapIndex)) ? (r(), l("g", Ma, [
          (r(), l("foreignObject", {
            x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) - 100 + e.drawingArea.width / e.maxSeries / 2,
            y: e.drawingArea.bottom,
            width: "200",
            height: "40",
            style: { overflow: "visible !important" }
          }, [
            f("div", {
              class: "vue-ui-xy-time-tag",
              style: L(`width: fit-content;margin: 0 auto;text-align:center;padding:3px 12px;background:${e.FINAL_CONFIG.chart.timeTag.backgroundColor};color:${e.FINAL_CONFIG.chart.timeTag.color};font-size:${e.FINAL_CONFIG.chart.timeTag.fontSize}px`)
            }, S(e.timeLabels[(t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)].text || (t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)), 5)
          ], 8, Ta)),
          f("circle", {
            cx: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            cy: e.drawingArea.bottom,
            r: e.FINAL_CONFIG.chart.timeTag.circleMarker.radius,
            fill: e.FINAL_CONFIG.chart.timeTag.circleMarker.color
          }, null, 8, Pa)
        ])) : c("", !0)
      ])) : c("", !0),
      w(a.$slots, "svg", { svg: e.svg }, void 0, !0)
    ], 14, Je)) : c("", !0),
    a.$slots.watermark ? (r(), l("div", Va, [
      w(a.$slots, "watermark", B(E({ isPrinting: t.isPrinting || t.isImaging })), void 0, !0)
    ])) : c("", !0),
    e.isDataset ? c("", !0) : (r(), D(T, {
      key: 6,
      config: {
        type: "line",
        style: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          line: {
            axis: {
              color: e.FINAL_CONFIG.chart.grid.stroke
            },
            path: {
              color: e.FINAL_CONFIG.chart.grid.stroke,
              strokeWidth: 0.5
            }
          }
        }
      }
    }, null, 8, ["config"])),
    e.FINAL_CONFIG.chart.zoom.show && t.maxX > 6 && e.isDataset ? (r(), D(v, {
      ref: "chartSlicer",
      key: `slicer_${t.slicerStep}`,
      background: e.FINAL_CONFIG.chart.zoom.color,
      fontSize: e.FINAL_CONFIG.chart.zoom.fontSize,
      useResetSlot: e.FINAL_CONFIG.chart.zoom.useResetSlot,
      labelLeft: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.start],
      labelRight: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.end - 1],
      textColor: e.FINAL_CONFIG.chart.color,
      inputColor: e.FINAL_CONFIG.chart.zoom.color,
      selectColor: e.FINAL_CONFIG.chart.zoom.highlightColor,
      borderColor: e.FINAL_CONFIG.chart.backgroundColor,
      minimap: e.minimap,
      smoothMinimap: e.FINAL_CONFIG.chart.zoom.minimap.smooth,
      minimapSelectedColor: e.FINAL_CONFIG.chart.zoom.minimap.selectedColor,
      minimapSelectionRadius: e.FINAL_CONFIG.chart.zoom.minimap.selectionRadius,
      minimapLineColor: e.FINAL_CONFIG.chart.zoom.minimap.lineColor,
      minimapSelectedColorOpacity: e.FINAL_CONFIG.chart.zoom.minimap.selectedColorOpacity,
      minimapSelectedIndex: t.selectedSerieIndex,
      minimapIndicatorColor: e.FINAL_CONFIG.chart.zoom.minimap.indicatorColor,
      max: t.maxX,
      min: 0,
      valueStart: t.slicer.start,
      valueEnd: t.slicer.end,
      start: t.slicer.start,
      "onUpdate:start": s[2] || (s[2] = (i) => t.slicer.start = i),
      end: t.slicer.end,
      "onUpdate:end": s[3] || (s[3] = (i) => t.slicer.end = i),
      refreshStartPoint: e.FINAL_CONFIG.chart.zoom.startIndex !== null ? e.FINAL_CONFIG.chart.zoom.startIndex : 0,
      refreshEndPoint: e.FINAL_CONFIG.chart.zoom.endIndex !== null ? e.FINAL_CONFIG.chart.zoom.endIndex + 1 : Math.max(...o.dataset.map((i) => e.largestTriangleThreeBucketsArray({ data: i.series, threshold: e.FINAL_CONFIG.downsample.threshold }).length)),
      onReset: e.refreshSlicer,
      onTrapMouse: e.selectMinimapIndex
    }, {
      "reset-action": M(({ reset: i }) => [
        w(a.$slots, "reset-action", B(E({ reset: i })), void 0, !0)
      ]),
      _: 3
    }, 8, ["background", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "borderColor", "minimap", "smoothMinimap", "minimapSelectedColor", "minimapSelectionRadius", "minimapLineColor", "minimapSelectedColorOpacity", "minimapSelectedIndex", "minimapIndicatorColor", "max", "valueStart", "valueEnd", "start", "end", "refreshStartPoint", "refreshEndPoint", "onReset", "onTrapMouse"])) : c("", !0),
    e.FINAL_CONFIG.chart.legend.show ? (r(), l("div", {
      key: 8,
      ref: "chartLegend",
      class: "vue-ui-xy-legend",
      style: L(`font-size:${e.FINAL_CONFIG.chart.legend.fontSize}px`)
    }, [
      (r(!0), l(I, null, m(e.absoluteDataset, (i, h) => (r(), l("div", {
        key: `div_legend_item_${h}`,
        onClick: (n) => e.segregate(i),
        class: V({ "vue-ui-xy-legend-item": !0, "vue-ui-xy-legend-item-segregated": t.segregatedSeries.includes(i.id) })
      }, [
        t.icons[i.type] === "line" ? (r(), l("svg", Da, [
          f("rect", {
            x: "0",
            y: "7.5",
            rx: "1.5",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": 0.5,
            height: "3",
            width: "20",
            fill: i.color
          }, null, 8, Ba),
          X(F, {
            plot: { x: 10, y: 9 },
            radius: 4,
            color: i.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(i.shape) ? i.shape : "circle",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            strokeWidth: 0.5
          }, null, 8, ["color", "shape", "stroke"])
        ])) : (r(), l("svg", Ea, [
          t.icons[i.type] === "bar" ? (r(), l("rect", {
            key: 0,
            x: "0",
            y: "0",
            rx: "1",
            height: "12",
            width: "12",
            stroke: "none",
            fill: i.color
          }, null, 8, Ha)) : (r(), D(F, {
            key: 1,
            plot: { x: 6, y: 6 },
            radius: 5,
            color: i.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(i.shape) ? i.shape : "circle"
          }, null, 8, ["color", "shape"]))
        ])),
        f("span", {
          style: L(`color:${e.FINAL_CONFIG.chart.legend.color}`)
        }, S(i.name), 5)
      ], 10, Ra))), 128))
    ], 4)) : (r(), l("div", Wa, [
      w(a.$slots, "legend", { legend: e.absoluteDataset }, void 0, !0)
    ], 512)),
    a.$slots.source ? (r(), l("div", Ya, [
      w(a.$slots, "source", {}, void 0, !0)
    ], 512)) : c("", !0),
    X(p, {
      show: t.mutableConfig.showTooltip && t.isTooltip,
      backgroundColor: e.FINAL_CONFIG.chart.tooltip.backgroundColor,
      color: e.FINAL_CONFIG.chart.tooltip.color,
      fontSize: e.FINAL_CONFIG.chart.tooltip.fontSize,
      borderRadius: e.FINAL_CONFIG.chart.tooltip.borderRadius,
      borderColor: e.FINAL_CONFIG.chart.tooltip.borderColor,
      borderWidth: e.FINAL_CONFIG.chart.tooltip.borderWidth,
      backgroundOpacity: e.FINAL_CONFIG.chart.tooltip.backgroundOpacity,
      position: e.FINAL_CONFIG.chart.tooltip.position,
      offsetY: e.FINAL_CONFIG.chart.tooltip.offsetY,
      parent: a.$refs.chart,
      content: e.tooltipContent,
      isFullscreen: t.isFullscreen,
      isCustom: e.FINAL_CONFIG.chart.tooltip.customFormat && typeof e.FINAL_CONFIG.chart.tooltip.customFormat == "function"
    }, {
      "tooltip-before": M(() => [
        w(a.$slots, "tooltip-before", B(E({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      "tooltip-after": M(() => [
        w(a.$slots, "tooltip-after", B(E({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      _: 3
    }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isFullscreen", "isCustom"]),
    e.isDataset ? (r(), D(z, {
      key: 11,
      hideDetails: "",
      config: {
        open: t.mutableConfig.showTable,
        maxHeight: 1e4,
        body: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        },
        head: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        }
      }
    }, {
      content: M(() => [
        f("div", {
          style: L(`${t.isPrinting ? "" : "max-height:400px"};overflow:auto;width:100%;margin-top:48px`)
        }, [
          f("div", Xa, [
            Ee(f("input", {
              type: "checkbox",
              "onUpdate:modelValue": s[4] || (s[4] = (i) => t.showSparklineTable = i)
            }, null, 512), [
              [He, t.showSparklineTable]
            ]),
            f("div", {
              onClick: s[5] || (s[5] = (i) => t.showSparklineTable = !t.showSparklineTable),
              style: { cursor: "pointer" }
            }, [
              X(O, {
                name: "chartLine",
                size: 20,
                stroke: e.FINAL_CONFIG.chart.color
              }, null, 8, ["stroke"])
            ])
          ]),
          t.showSparklineTable ? (r(), D(_, {
            key: `sparkline_${t.segregateStep}`,
            dataset: e.tableSparklineDataset,
            config: e.tableSparklineConfig
          }, null, 8, ["dataset", "config"])) : (r(), D(C, {
            key: `table_${t.tableStep}`,
            colNames: e.dataTable.colNames,
            head: e.dataTable.head,
            body: e.dataTable.body,
            config: e.dataTable.config,
            title: `${e.FINAL_CONFIG.chart.title.text}${e.FINAL_CONFIG.chart.title.subtitle.text ? ` : ${e.FINAL_CONFIG.chart.title.subtitle.text}` : ""}`,
            onClose: s[6] || (s[6] = (i) => t.mutableConfig.showTable = !1)
          }, {
            th: M(({ th: i }) => [
              f("div", { innerHTML: i }, null, 8, qa)
            ]),
            td: M(({ td: i }) => [
              We(S(isNaN(Number(i)) ? i : e.dataLabel({
                p: e.FINAL_CONFIG.chart.labels.prefix,
                v: i,
                s: e.FINAL_CONFIG.chart.labels.suffix,
                r: e.FINAL_CONFIG.table.rounding
              })), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ], 4)
      ]),
      _: 1
    }, 8, ["config"])) : c("", !0)
  ], 14, Ue);
}
const ci = /* @__PURE__ */ Ye(qe, [["render", Ua], ["__scopeId", "data-v-c43c1c59"]]);
export {
  ci as default
};
